<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 23/11/2015
 * Time: 17:30
 */

namespace Teknisa\CRM\Controller;

use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO\Response\Message;
use Teknisa\CRM\Service\RecuperarSenhaService;
use Teknisa\CRM\Service\Login;

class RecuperarSenhaController extends \Zeedhi\Framework\Controller\Simple {

    protected $recuperarSenhaService;
    protected $loginService;

    public function __construct(RecuperarSenhaService $recuperarSenhaService, Login $loginService) {
        $this->recuperarSenhaService = $recuperarSenhaService;
        $this->loginService = $loginService;
    }

    public function recuperarSenhaViaEmail($request, $response) {

        $dataset = $request->getDataSet();
        $dataset = $dataset->getRows();

        try {

            $operador = $this->loginService->retornaOperadorPorEmail($dataset[0]["DSEMAILOPER"]);

            if($operador)
                $return = $this->recuperarSenhaService->enviaEmailNovaSenha($operador[0]['DSEMAILOPER'], $operador[0]['NRORG'], $operador[0]['NMOPERADOR']);
            else
                $return = null;

            if ($return) {
                $response->addMessage(new Message('Sua nova senha foi enviada para o seu email.'));
            } else {
                $response->addMessage(new Message('Não foi possível enviar o email com sua nova senha. Contate o administrador.'));
            }

        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }

    }

}