<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 14/09/2015
 * Time: 15:25
 */

namespace Teknisa\CRM\Controller;
use Zeedhi\Framework\DataSource\Manager;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Response;


class crm00030000NotificacoesController extends TeknisaCrud
{
    protected $dataSourceName = 'crm_notificacoes_crm_relacopernotificacao_operador';
	/** @var  EntityManager */
    protected $entityManager;
    protected $connection;

    public function __construct($crudService, $parameterBag, $entityManager)
    {
	   	$this->entityManager = $entityManager;
	   	$this->connection    = $entityManager->getConnection();

        parent::__construct($crudService, $parameterBag);
    }

    public function trocaValorNotificacao(Row $row, Response $response)
    {
    	$getRow 	  = $row->getRow();
        $notificacoes = $getRow['notificacoes'];
        $idconfirma   = $getRow['idconfirma'];

        if(self::checaConfirmacaoNotificacao($notificacoes)  == null)
        {
	        if($idconfirma == 'R')
	        {
	        	self::voltarValorNotificacao($notificacoes);
	        }

	        self::confirmaMudancaNotificacao($notificacoes, $idconfirma);
    	}
    }

    public function voltarValorNotificacao($notificacoes)
    {
		if($notificacoes["DSEVENTONOTIFICACAO"] == "SITUACAO")
		{
			$table = "CONTATO";
			$field = "NRSEQSITUACAO";
			$key   = "NRSEQCONTATO";
		}
		else if($notificacoes["DSEVENTONOTIFICACAO"] == "FASENEGOCIO")
		{
			$table = "CRM_OPORTUNI";
			$field = "NRSEQFASENEGO";
			$key   = "NRSEQOPORT";
		}

		if(isset($table))
		{
			$update  = "UPDATE ".$table;
			$update .= "   SET ".$field." = :".$field;
			$update .= " WHERE ".$key."   = :".$key;
			$update .= "   AND NRORG      = :NRORG";

			$params = array
	        (
	            "NRORG" => $notificacoes["NRORG"],
	            $key    => $notificacoes["CDORIGNOTIFICACAO"],
	            $field  => $notificacoes["VRFIELDANTE"]
            );

	        try
	        {
	            $std = $this->connection->prepare($update);
	            $std->execute($params);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }
	    }
    }

    public function confirmaMudancaNotificacao(array $row, $id)
    {
    	$update = "UPDATE CRM_NOTIFICACOES
    				  SET IDACEITARECUSA   = :IDACEITAREUCSA
    				WHERE NRSEQNOTIFICACAO = :NRSEQNOTIFICACAO
    				  AND NRORG            = :NRORG";
	    $params = array
        (
            "NRORG" 		   => $row["NRORG"],
            "NRSEQNOTIFICACAO" => $row["NRSEQNOTIFICACAO"],
            "IDACEITAREUCSA"   => $id
        );

        try
        {
            $std = $this->connection->prepare($update);
            $std->execute($params);
        }catch (\Exception $e)
        {
            throw $e;
        }
    }

    public function checaConfirmacaoNotificacao(array $row)
    {
    	$select = "SELECT IDACEITARECUSA
                     FROM CRM_NOTIFICACOES
                    WHERE NRSEQNOTIFICACAO = :NRSEQNOTIFICACAO
                      AND NRORG     	   = :NRORG";

        $params = array
        (
        	"NRSEQNOTIFICACAO" => $row["NRSEQNOTIFICACAO"],
        	"NRORG" 		   => $row["NRORG"]
        );
        $std = $this->entityManager->getConnection()->prepare($select);
        $std->execute($params);

        $result = $std->fetchAll();

        return $result[0]["IDACEITARECUSA"];
    }

    public function deletaRelacaoNotificacao(Row $row, Response $response)
    {
    	$notificacoes = $row->getRow();

		foreach($notificacoes as $notificacao)
		{
	        $delete = "DELETE CRM_RELACOPERNOTIFICACAO
	                    WHERE NRSEQNOTIFICACAO = :NRSEQNOTIFICACAO
	                      AND CDOPERNOTIFICADO = :CDOPERNOTIFICADO
	                      AND NRORG            = :NRORG";

	        $params = array
	        (
	            "NRORG"            => $notificacao["NRORG"],
	            "NRSEQNOTIFICACAO" => $notificacao["NRSEQNOTIFICACAO"],
	            "CDOPERNOTIFICADO" => $notificacao["CDOPERNOTIFICADO"]
            );

	        try
	        {
	            $std = $this->connection->prepare($delete);
	            $std->execute($params);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }

            if(self::NotificacaoRelacionado($notificacao) == 0)
            {
                self::deletaNotificacao($notificacao);
            }
    	}
    }



    public function NotificacaoRelacionado(array $row)
    {
    	$select = "SELECT COUNT(*) AS COUNT
                     FROM CRM_RELACOPERNOTIFICACAO
                    WHERE NRSEQNOTIFICACAO = :NRSEQNOTIFICACAO
                      AND NRORG            = :NRORG";

        $params = array
        (
            "NRSEQNOTIFICACAO" => $row["NRSEQNOTIFICACAO"],
            "NRORG"            => $row["NRORG"]
        );

        try
        {
            $std = $this->entityManager->getConnection()->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
        }
        catch(\Exception $e)
        {
            var_dump($row);
        };

        return $result[0]["COUNT"];
    }

    public function deletaNotificacao(array $row)
    {
        $delete = "DELETE CRM_NOTIFICACOES
                    WHERE NRSEQNOTIFICACAO = :NRSEQNOTIFICACAO
                      AND NRORG            = :NRORG";

        $params = array
        (
            "NRORG"            => $row["NRORG"],
            "NRSEQNOTIFICACAO" => $row["NRSEQNOTIFICACAO"]
        );

        try
        {
            $std = $this->connection->prepare($delete);
            $std->execute($params);
        }catch (\Exception $e)
        {
            throw $e;
        }
    }
}
?>