<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;

use Teknisa\CRM\Service\GeralService;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\NewCode;

class crm00032001ParametrosNegociacaoController extends TeknisaCrud {
    protected $dataSourceName = 'crm_paramfasenego_crm_fields';
    protected $parameterBagColumns = array('P_NRORG', 'P_NRSEQFASENEGO');
    protected $newCode;
    
    public function __construct($crudService, $parameterBag, NewCode $newCode) {
        parent::__construct($crudService, $parameterBag);
        $this->newCode = $newCode;
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        foreach($request->getDataSet()->getRows() as $row) {
            if(!array_key_exists('DTULTATU', $row)) $row['DTULTATU'] = null;
            if(!array_key_exists('NRORGULTATU', $row)) $row['NRORGULTATU'] = null;
            if(!array_key_exists('CDOPERULTATU', $row)) $row['CDOPERULTATU'] = null;
            if(!array_key_exists('IDATIVO', $row)) $row['IDATIVO'] = 'S';

            $fields = $row['NRFIELDCRM'];
            foreach($fields as $field){
                $row['NRSEQCAMPOOBRIGA'] = $field;
                if($row['__is_new']){
                    $row['NRPARAMFASENEGO'] = $this->newCode->getCodeByTableName("CRM_PARAMFASENEGO", $row["NRORG"]);
                    date_default_timezone_set('America/Sao_Paulo');
                    $row['DTINCLUSAO'] = date('d/m/y');
                } else {
                    date_default_timezone_set('America/Sao_Paulo');
                    $row['DTULTATU'] = date('d/m/y');
                }
                parent::save($request, $response);
            }
        }
    }

}