/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRESENTENVICLI                                           */
/* Tabela : PRESENTENVICLI                                                    */
/*                                                                            */
/* Criao:                                                                   */
/* 01/09/2009 - Tarcsio Dias Pereira                                         */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRESENTENVICLI
BEFORE INSERT OR UPDATE OR DELETE
ON PRESENTENVICLI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCLIENTE,0) <> NVL(:NEW.CDCLIENTE,0)) OR
         (NVL(:OLD.CDINTECLIE,0) <> NVL(:NEW.CDINTECLIE,0)) OR
         (NVL(:OLD.CDPRESENTE,0) <> NVL(:NEW.CDPRESENTE,0)) OR
         (NVL(:OLD.DTENVPRESCLI,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTENVPRESCLI,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
         (NVL(:OLD.DSOBSPRESENV,0) <> NVL(:NEW.DSOBSPRESENV,0)) THEN
	:NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRESENTENVICLI', '', 'CDCLIENTE ='||:OLD.CDCLIENTE||';CDINTECLIE ='||:OLD.CDINTECLIE||';CDPRESENTE ='||:OLD.CDPRESENTE||';DTENVPRESCLI='||TO_CHAR(:OLD.DTENVPRESCLI,'DD/MM/YYYY HH24MISS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRESENTENVICLI MODIFY DTULTATU DEFAULT SYSDATE;