function ImportacaoProspectController(ScreenService, templateManager, Utilities, restEngine, Operador_Repository, metaDataFactory) {

    this.downloadPlanilhaModelo = function() {
        var filename = 'template_importacao_mailing.xls';
        window.open("files/" + filename, "_blank");
    };

    this.uploadPlanilhaModelo = function() {
        var widget = templateManager.container.getWidget('WDGT_UPLOAD_PLANILHA');
        widget.isVisible = true;
        ScreenService.openPopup(widget);
    };
    
    this.confirmUploadPlanilha = function(args) {
        var widget = args.owner.widget;
        var mainWid = widget.parent.parent;
        if (widget.isValid()) {
            var validationFile = this.verificaExtensaoArquivo(widget.currentRow);
            if (validationFile) {
                widget.currentRow.NRPARCNEGOCIO_OPER = templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO;
                return restEngine.post("/saveUploadFile",{
                        requestType: "DataSet",
                        dataset: [widget.currentRow]
                    }, null, null, null, null, 900000000000000000
                ).then(function (response) {
                    if (!Util.isUndefined(response.dataset.saveUploadFile) && response.dataset.saveUploadFile[0] === true) {
                        mainWid.dataSource.data = [];
                        widget.isVisible = false;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage("Arquivo '" + widget.currentRow.FILEPATH[0].name + "' carregado com sucesso.");
                    } else if (!Util.isUndefined(response.dataset.saveUploadFile) && !Util.isUndefined(response.dataset.saveUploadFile[0].error)) {
                        var inconsistencias = response.dataset.saveUploadFile[0].error;
                        //Percorre o objeto 'error' inserindo as inconsistencias no datasource da widget.
                        var newData = Object.keys(inconsistencias).map(function(key){
                            return inconsistencias[key];
                        });
                        //insere no datasource
                        mainWid.dataSource.data = newData;
                        widget.isVisible = false;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage('Importação finalizada, verifique as inconsistências.');
                    } else {
                        ScreenService.showMessage("Não foi possível realizar o upload do arquivo '" + widget.currentRow.FILEPATH[0].name + "'.");
                    }
                }).catch(function(e) {
                    if (!Util.isUndefined(e.data) && e.data !== null)
                        ScreenService.showMessage(e.data.error);
                    else    
                        ScreenService.showMessage(e.message);
                        
                    mainWid.dataSource.data = [];
                    ScreenService.closePopup(true);
                });
            }
        }
    };
    
    this.widgetOnEnter = function(args) {
        var widget = args.owner;
        
        widget.currentRow.DTPLANFILACONTA = moment().format('DD/MM/YYYY HH:mm');
        widget.currentRow.DTHREVOLCONT = moment().format('DD/MM/YYYY');
    };
    
    this.onChangeGeraTarefa = function(args) {
        var widget = args.owner.field.widget;
        if (args.row.IDGERATAREFA == 'S') {
            widget.getField('DTPLANFILACONTA').validations = {"required": {}};
            widget.getField('NRPRIORFILACONT').validations = {"required": {}};
            widget.getField('DSFILACONTATO').validations = {"required": {}};
            widget.getField('DTPLANFILACONTA').readOnly = false;
            widget.getField('NRPRIORFILACONT').readOnly = false;
            widget.getField('NMOPERREAL').readOnly      = false;
            widget.getField('DSFILACONTATO').readOnly   = false;
        } else {
            widget.getField('DTPLANFILACONTA').validations = {};
            widget.getField('NRPRIORFILACONT').validations = {};
            widget.getField('DSFILACONTATO').validations = {};
            widget.getField('DTPLANFILACONTA').readOnly = true;
            widget.getField('NRPRIORFILACONT').readOnly = true;
            widget.getField('NMOPERREAL').readOnly      = true;
            widget.getField('DSFILACONTATO').readOnly   = true;
        }
        
        widget.reload();
    };
    
    this.onChangeGeraEvolucao = function(args) {
        var widget = args.owner.field.widget;
        if (args.row.IDGERAEVOLUCAO == 'S') {
            widget.getField('NMTIPOCONT').validations    = {"required": {}};
            widget.getField('NMMOTIEVOCON').validations  = {"required": {}};
            widget.getField('DESCRESULEVOL').validations = {"required": {}};
            widget.getField('TXEVOLCONT').validations    = {"required": {}};
            widget.getField('NMTIPOCONT').readOnly       = false;
            widget.getField('NMMOTIEVOCON').readOnly     = false;
            widget.getField('DESCRESULEVOL').readOnly    = false;
            widget.getField('TXEVOLCONT').readOnly       = false;
        } else {
            widget.getField('NMTIPOCONT').validations    = {};
            widget.getField('NMMOTIEVOCON').validations  = {};
            widget.getField('DESCRESULEVOL').validations = {};
            widget.getField('TXEVOLCONT').validations    = {};
            widget.getField('NMTIPOCONT').readOnly       = true;
            widget.getField('NMMOTIEVOCON').readOnly     = true;
            widget.getField('DESCRESULEVOL').readOnly    = true;
            widget.getField('TXEVOLCONT').readOnly       = true;
        }
        
        widget.reload();
    };
    
    this.onChangeTipoParceiro = function(args) {
        var widget = args.owner.field.widget;
        if (args.row.TIPODEPARCEIRO == 'CANDIDATO') {
            widget.getField('IDGERATAREFA').readOnly    = true;
            widget.getField('IDGERATAREFA').validations = {};
            widget.getField('IDGERATAREFA').hideEmptyValue = false;
            args.row.IDGERATAREFA = 'N';
            this.onChangeGeraTarefa(args);
            widget.getField('IDGERAEVOLUCAO').readOnly = true;
            widget.getField('IDGERAEVOLUCAO').validations = {};
            widget.getField('IDGERAEVOLUCAO').hideEmptyValue = false;
            args.row.IDGERAEVOLUCAO = 'N';
            this.onChangeGeraEvolucao(args);
            
        } else {
            widget.getField('IDGERATAREFA').readOnly = false;
            widget.getField('IDGERATAREFA').validations = {"required":{}};
            widget.getField('IDGERATAREFA').hideEmptyValue = true;
            widget.getField('IDGERAEVOLUCAO').readOnly = false;
            widget.getField('IDGERAEVOLUCAO').validations = {"required":{}};
            widget.getField('IDGERAEVOLUCAO').hideEmptyValue = true;
        }
        
        widget.reload();
    };
    
    this.verificaExtensaoArquivo = function(argsRow){
        var bool = true;
        if (!Util.isUndefined(argsRow.FILEPATH) && argsRow.FILEPATH.length > 0) {
            var extencoes = ['xls', 'xlsx'];            
            $.each(argsRow.FILEPATH, function (key, value) {
                var tipo = argsRow.FILEPATH[key].name.split('.');
                if (extencoes.indexOf(tipo[1]) == -1) {
                    ScreenService.showMessage('Favor selecionar arquivos no formato XLS, XLSX ou CSV');
                    bool = false;
                }
            });
        } else {
            ScreenService.showMessage('Favor selecionar um arquivo no formato XLS, XLSX ou CSV');
            bool = false;
        }

        return bool;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ImportacaoProspectController', ImportacaoProspectController);
});